(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2012 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)

(*
  Time-stamp: <Last modified on 2013-02-14 16:14:44 CET by Kim Nguyen>
*)

include Hcons.Make (struct
  include String
  let hash s = Hashtbl.hash s
  let equal s1 s2 = s1 = s2
end)

let print pp s = Format.fprintf pp "%s" s.node

let of_string = make
let to_string = node

let document = of_string "#document"
let text = of_string "#text"
let cdata_section = of_string "#cdata-section"
let comment = of_string "#comment"
let document_fragment = of_string "#document-fragment"
let attribute_map = of_string "#attribute-map"
let nil = of_string "#"
let attribute_prefix = of_string "@"
let has_attribute_prefix s =
  let s = node s in
  String.length s > 0 && s.[0] = '@'

let add_attribute_prefix s =
  of_string ("@" ^ (node s))
